<template>
  <div>
    <slot
      :toggle="toggle"
      :shown="shown"
    >
      <button @click="toggle(!shown)">toggle</button>
    </slot>
    <div
      v-if="shown"
      ref="target"
      class="relative antialiased"
    >
      <Transition
        name="fade"
        appear
      >
        <ul
          class="absolute right-0 top-4 z-10 grid w-max origin-top-right grid-cols-[20px_1fr] items-center rounded-md bg-white px-3 py-4 shadow-[0_8px_20px_rgba(0,0,0,0.1)] shadow-slate-300 transition-all"
        >
          <li
            v-for="elem in modelValue"
            :key="elem.title"
            class="group/menu-elem contents"
          >
            <img
              class="h-full w-auto self-center brightness-[.100] contrast-[.91] hue-rotate-[176deg] invert-[.33] saturate-[.513] sepia-[.23] transition-all group-hover/menu-elem:scale-125 group-hover/menu-elem:brightness-[.94] group-hover/menu-elem:contrast-[.100] group-hover/menu-elem:hue-rotate-[65deg] group-hover/menu-elem:invert-[.41] group-hover/menu-elem:saturate-[.3858] group-hover/menu-elem:sepia-[.33]"
              :src="elem.icon"
            />
            <button
              class="py-2 pl-3 text-left font-normal text-slate-600 transition-all group-hover/menu-elem:text-fuchsia-500"
              @click="select(elem)"
            >
              {{ elem.title }}
            </button>
          </li>
        </ul>
      </Transition>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { type IDropdownElem } from '~shared/model';
import { onClickOutside, useToggle } from '@vueuse/core';

const props = withDefaults(
  defineProps<{
    modelValue: IDropdownElem[];
    isShowWhenSelectings?: boolean;
  }>(),
  { isShowWhenSelectings: false },
);

const [shown, toggle] = useToggle();
const select = (elem: IDropdownElem) => {
  elem.action();
  if (!props.isShowWhenSelectings) {
    shown.value = false;
  }
};

const target = ref(null);
onClickOutside(target, () => toggle());
</script>
